#include "Ball.h"

Ball::Ball()
{
    
}

Ball::~Ball()
{
    
}
//initialise ball and its parameters
void Ball::init(float x, float y, int radius, bool colour)
{
    _x = x; //x coordinate of ball centre
    _y = y; //y coordinate of ball centre
    _radius = radius; //radius of ball
    _colour = colour; //colour/type of ball
    
}
 



 // get struct containing information on current ball velocity
Vector2D Ball::getSpeed()
{
    Vector2D _velocity = {velocity.x, velocity.y};
    return _velocity;
}

 
 // get struct containing information on current ball position
Vector2D Ball::getPosition()
{
    Vector2D p = {_x,_y};
    
    return p;
}



//update ball position structured as a 2D vector
void Ball::update(Vector2D position)
{
  velocity = position;
    
    // new coordinates for the centre of the ball
    _x += velocity.x*2;
    _y -= velocity.y*2 ;   // +ve y joystick motion => -ve ball motion
}





//set ball speed
void Ball::setSpeed(Vector2D v)
{
    velocity.x = v.x;
    velocity.y = v.y;
}



//set ball position
void Ball::setPosition(Vector2D p)
{
    _x = p.x;
    _y = p.y;
}




//goes to draw function within game engine then called upon in playGame function
void Ball::draw(N5110 &lcd) 
{
    if (_colour){
        lcd.drawCircle(_x, _y, _radius, FILL_TRANSPARENT);
    }
    else { 
        lcd.drawCircle(_x, _y, _radius, FILL_BLACK);
    }
    
}
